library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;


---- function
package controlFuncs is
 function nextPlayerID(vec : std_logic_vector) return std_logic_vector;
 function stdv2str(vec:std_logic_vector) return string;
 function stdv2signed(vec:std_logic_vector) return integer ;

end controlFuncs;

package body controlFuncs is
  function nextPlayerID(vec : std_logic_vector) return std_logic_vector is
    variable nextID : std_logic_vector(vec'left downto 0);

  begin
    nextID := vec;
    nextID := nextID + nextID;
    if nextID = X"0" then
      nextID(0) := '1';
    end if;
    
    return nextID;
  end;




	function stdv2str(vec:std_logic_vector) return string is
		variable str: string(vec'left+1 downto 1);

	begin
	for i in vec'reverse_range loop
		if(vec(i)='U') then
			str(i+1) := 'U';
		elsif(vec(i)='X') then
			str(i+1) := 'X';
		elsif(vec(i)='0') then
			str(i+1) := '0';
		elsif(vec(i)='1') then
			str(i+1) := '1';
		elsif(vec(i)='Z') then
			str(i+1) := 'Z';
		elsif(vec(i)='W') then
			str(i+1) := 'W';
		elsif(vec(i)='L') then
			str(i+1) := 'L';
		elsif(vec(i)='H') then
			str(i+1) := 'H';
		else
			str(i+1) := '-';
		end if;
	end loop;
	return str;
	end;
	
	function stdv2signed(vec:std_logic_vector) return integer is
		variable int1 : integer;
		variable int2 : integer;
		
	begin
	
		int1 := CONV_INTEGER(vec);
		--report "entering func";
		if int1 > 32768 then  -- number might be 1 off
			int2 := int1 - 65536;
			--report integer'image(int2) & " <- is neg the num";
		else
			int2 := int1;
			--report integer'image(int2) & " <- is the posnum";
		end if;
		--report "exiting func";
	
	return int2;	
        end;


end controlFuncs;
